? kadischi-squash-only.patch
Index: linuxrc/livecd-linuxrc
===================================================================
RCS file: /cvs/devel/kadischi/linuxrc/livecd-linuxrc,v
retrieving revision 1.3
diff -u -r1.3 livecd-linuxrc
--- linuxrc/livecd-linuxrc	30 Mar 2006 10:13:12 -0000	1.3
+++ linuxrc/livecd-linuxrc	10 Apr 2006 19:04:15 -0000
@@ -17,15 +17,10 @@
 # Make kernel don't mount root fs
 echo 0x100 > /proc/sys/kernel/real-root-dev
 
-# Check for squashfs file
-if [ -f /cdrom/kadischi.sqsh ]; then
-    echo "Mounting squashfs filesystem"
-    modprobe loop
-    modprobe squashfs
-    mount -t squashfs -o loop /cdrom/kadischi.sqsh /sysroot
-else
-    mount -o bind /cdrom /sysroot
-fi
+echo "Mounting root filesystem"
+modprobe loop
+modprobe squashfs
+mount -t squashfs -oloop,ro /cdrom/kadischi.sqsh /sysroot
 
 echo "Doing the pivot_root"
 cd /sysroot
Index: livecd_generator/kadischi.py
===================================================================
RCS file: /cvs/devel/kadischi/livecd_generator/kadischi.py,v
retrieving revision 1.9
diff -u -r1.9 kadischi.py
--- livecd_generator/kadischi.py	4 Apr 2006 13:43:13 -0000	1.9
+++ livecd_generator/kadischi.py	10 Apr 2006 19:04:16 -0000
@@ -48,8 +48,6 @@
 
 parser.add_option ("", "--buildstamp", dest="buildstamp", help="buildstamp file (if not set, using the default buildstamp from the config directory)")
 
-parser.add_option ("", "--filesystem", dest="filesystem", help="set the filesystem to use on the iso to either zisofs[default] or squashfs.")
-
 flc_log ('Parsing command line arguments')
 (options, args) = parser.parse_args ()
 
@@ -158,13 +156,7 @@
 
 flc_log ('Checking required packages')
 
-# Set required filesystem_tools to something appropriate depending on what is chosen
-if options.filesystem == 'squashfs':
-   filesystem_tools = 'squashfs-tools'
-else:
-   filesystem_tools = 'zisofs-tools'
-
-required_rpms = ('anaconda', 'busybox-anaconda', 'mkisofs', 'syslinux', 'e2fsprogs', filesystem_tools)
+required_rpms = ('anaconda', 'busybox-anaconda', 'mkisofs', 'syslinux', 'e2fsprogs', 'squashfs-tools')
 
 missing_rpms = check_installed_rpms ('/', required_rpms, False)
 
@@ -259,10 +251,7 @@
 
 flc_log ('making initrd image')
 
-if options.filesystem == 'squashfs':
-    kmods = 'fs/squashfs drivers/block/loop.ko'
-else:
-    kmods = ''
+kmods = 'fs/squashfs drivers/block/loop.ko'
 
 run ("KMODULES='%s' %s %s %s" % (kmods, normalize_path([bindir, 'livecd-mkinitrd.sh']), sysdir, kernel_version), builddir)
 
@@ -276,19 +265,14 @@
 
 flc_log ('compressing the tree (order a pizza `cause this will take a while)')
 
-if options.filesystem == 'squashfs':
-    # zisofs has a tree which can be seen; squashfs is a file that we mount
-    # loopback.  So we need to create supporting files and directories
-    # separately.
-    os.makedirs (os.path.join(csysdir, 'boot/isolinux'))
-    os.makedirs(normalize_path([csysdir, '/livecd']))
-    touch = file(normalize_path([csysdir, '.livecd']), 'w')
-    touch.close()
-    # compress a squashfs tree
-    run("mksquashfs %s %s" % (sysdir, normalize_path([csysdir, 'kadischi.sqsh'])))
-else:
-    # compress a zisofs tree
-    run ("mkzftree -z 3 %s %s" % (sysdir, csysdir), builddir)
+# squashfs is a file that we mount loopback.  So we need to create supporting
+# files and directories outside the compressed tree.
+os.makedirs (os.path.join(csysdir, 'boot/isolinux'))
+os.makedirs(normalize_path([csysdir, '/livecd']))
+touch = file(normalize_path([csysdir, '.livecd']), 'w')
+touch.close()
+# compress the squashfs tree
+run("mksquashfs %s %s" % (sysdir, normalize_path([csysdir, 'kadischi.sqsh'])))
 
 # install boot & conf files in compressed tree (they shoudn`t be compressed)
 
@@ -308,10 +292,8 @@
 
 flc_log ('creating iso image %s' % isoimage)
 
-if options.filesystem == 'squashfs':
-    mkisoflags=''
-else:
-    mkisoflags='MKISOFSOPTION=-z '
+# Pass extra options to mkisofs through this variable
+mkisoflags=''
 run ("%s%s %s %s" % (mkisoflags, normalize_path([bindir, 'create-iso.sh']), csysdir, isoimage), builddir)
 
 # delete builddir
Index: man/kadischi.1
===================================================================
RCS file: /cvs/devel/kadischi/man/kadischi.1,v
retrieving revision 1.2
diff -u -r1.2 kadischi.1
--- man/kadischi.1	4 Apr 2006 13:43:13 -0000	1.2
+++ man/kadischi.1	10 Apr 2006 19:04:16 -0000
@@ -6,13 +6,13 @@
 kadischi - generate a live ISO9660 CDROM image from an RPM repository
 .SH SYNOPSIS
 kadischi [--text|--graphical] [--kickstart=<ks-file>] [-C|--cmdline]
-[--filesystem=<fstype>] REPOSITORY [-f] IMAGE
+REPOSITORY [-f] IMAGE
 .SH DESCRIPTION
 .B kadischi(1)
 generates a live ISO9660 CDROM image from an RPM repository tree by invoking
 anaconda passing it the correct options and installing to the build
 directory specified. Kadischi will invoke 
-.BR mkzftree(1)
+.BR mksquashfs(1)
 and
 .BR mkisofs(1)
 to produce an image that can be written to a CD or DVD ROM.
@@ -29,10 +29,6 @@
 Run strictly in command line mode requiring no user input.
 .IP --cmdline
 Same as -C
-.IP --filesystem
-The filesystem type which should be used for the root filesystem of the LiveCD,
-where fstype is one of 'zisofs' or 'squashfs'.
-The default is zisofs.
 .IP -f
 Overwrite an existing ISO9660 image, if it already exists.
 .SH FILES
@@ -65,7 +61,7 @@
 .RS
 Chitlesh Goorah <chitlesh@fedoraproject.org>
 .SH "SEE ALSO"
-.BR mkzftree(1),
+.BR mksquashfs(1),
 .BR mkisofs(1),
 .BR busybox(1),
 .BR anaconda(1)